	SUBROUTINE BINT(T,BB)
C   THIS SUBROUTINE INTEGRATES pi*Bnu(T)
C   NOTE : CHECK THE BIN LIMITS TO ENSURE CORRECT RANGE OF INTEGRATION
	DIMENSION X(500),Y(500)
	CONST = 8.7308E-6
	X2   = 1.578E+5/T
	NBIN = 300
	X1 = .01
	STEP = (X2 - X1)/(NBIN-1)
	X(1) = X1
	DO 100 I=1,NBIN
	X(I) = X1 + (I-1)*STEP		
	Y(I) = (X(I)**3)*EXP(-X(I))/(1.0-EXP(-X(I)))
100	CONTINUE
	CALL ONETEG(X,Y,TEG,NBIN)
	BB = TEG*CONST*(T**4)
	WRITE(6,*)'BB=',BB
	RETURN
	END
