	SUBROUTINE DBCREK
C   DBCREK LOADS THE ARRAYS TEMP,CHIJ AND CPLNK FOR USE IN
C   THE TEMPERATURE CORRECTION SUBROUTINE BCREK AND CALCULATES GAS TEMP
	COMMON/ATMSP/TEMP(200),DENST(200)
        COMMON/FRAC/ P(200),R(300),NR,NP,PINDEX(200)
        COMMON/BLANK1/XM(200),YM(200),SM(200),DUM1(200)
	COMMON/DUST4/DCAPCA(150,25,200),DCAPSA(150,25,200),DTEMP(2,25,200),
     1     DPLNK(2,25,200),DCHIJ(2,25,200)
	COMMON/RT/CA(150,200),CASC(200),CROSS(200)
	COMMON/INTRG/II,III,NFREQ
	COMMON/NNN/NC(200),NS(200),DENS,NCSAV,NSSAV
	COMMON/BCREK/AJ(200),AH(200),AK(200),CPLNK(200)
	COMMON/FCTRS/FHJTOT,FKJTOT(200),CHIJ(200),CHIF(200),
     1	   QSPTOT(200),CHFT(200)
	COMMON/WTS/A(25),CC(25,200),CS(25,200),CONST(2,25)
	COMMON/GDIST/ROG(2),AG(2,25,200),AN(2,25,200),W(2,25,200)
	DIMENSION CJKEEP(200),CPKEEP(200),TKEEP(200)
	DIMENSION Y1(25),Y2(25),AX(25),DT(25),C1(25),YPR(200)
      DO 9125 I=1,NR
      FKJTOT(I)=AK(I)/AJ(I)
      XM(I)=ALOG(R(I))
      YM(I)=3.-1./FKJTOT(I)
 9125 CONTINUE
      IDRIV=0
      IFORW=1
      CALL ONESPL(XM,YM,SM,YP1,YPN,YPR,NR,IDRIV)
      CALL XISPLI(XM,YM,SM,DUM1,NR,IFORW)
      DO 9129 I=1,NR
 9129 QSPTOT(I)=EXP(DUM1(I))
	DO 10 I=1,III
	CJKEEP(I) = CHIJ(I)
	CPKEEP(I) = CPLNK(I)
	TKEEP(I) = TEMP(I)
	CHIJ(I) = 0.0
	CPLNK(I) = 0.0
	TEMP(I) = 0.0
10	CONTINUE
	NX = NC(1)
	DO 100 ICHEM=1,2
	IF(ICHEM.EQ.2) NX = NS(1)
	DO 100 IA=1,NX
	DO 50 I=1,III
	CHIJ(I) = DCHIJ(ICHEM,IA,I)
	TEMP(I) = DTEMP(ICHEM,IA,I)
	CPLNK(I)= DPLNK(ICHEM,IA,I)
50	CONTINUE
	CALL BCREC(AJ,AH,CROSS,CPLNK,AK)
	DO 75 I=1,III
75	DTEMP(ICHEM,IA,I) = TEMP(I)
100	CONTINUE		
	DO 125 I= 1,III
	CHIJ(I) = CJKEEP(I)
	CPLNK(I) = CPKEEP(I)
	TEMP(I) = TKEEP(I)
125	CONTINUE
	DO 175 I=1,III
	TN = 0.0
	TD = 0.0
	TNT = 0.0
	TDT = 0.0
	CTEST = 0.0
	DO 160 ICHEM=1,2
	GO TO (130,140)ICHEM
130	     NX = NC(I)
	     DO 135 IA=1,NX
	     AX(IA) = AG(ICHEM,IA,I)
	     DT(IA) = DTEMP(ICHEM,IA,I)
	     C1(IA) = CC(IA,I)
	     CTEST = AMAX1(C1(IA),CTEST)
135	     CONTINUE
C  CHECK FOR ZERO NUMBER ABUNANCE AT INNER EDGE
C	     IF(I.EQ.1.AND.C1(IA).EQ.0)C1(IA)=CC(IA,2)
             GO TO 150
140	     NX = NS(I)
	     DO 145 IA=1,NX
	     AX(IA) = AG(ICHEM,IA,I)
	     DT(IA) = DTEMP(ICHEM,IA,I)
	     C1(IA) = CS(IA,I)
C  CHECK FOR ZERO NUMBER ABUNANCE AT INNER EDGE
C	     IF(I.EQ.1.AND.C1(IA).EQ.0)C1(IA)=CS(IA,2)
145	     CONTINUE
150	CONTINUE
	DO 155 IA=2,NX
	AVEA = C1(IA)*(AX(IA)+AX(IA-1))*0.5		
	AVET = (DT(IA)+DT(IA-1))*0.5
	Y1(IA-1) = AVET*(AVEA**2)
	Y2(IA-1) = AVEA**2
155	CONTINUE
	CALL TWOTEG(AX,Y1,TN,Y2,TD,C1,NX)
	TNT = TNT+TN
	TDT = TDT+TD
160	CONTINUE
C ** TEST CASE
	IF((TDT.LE.0.0).OR.(TNT.LE.0.0)) THEN
	WRITE(11,1300)TN,TNT,TD,TDT
1300    FORMAT(' TN,TNT,TD,TDT',4E11.3)
	DO 3000 JCHEM =1,2
	DO 1500 JA = 1,3
	JB = ((JA-1)*5)+1
	JE = JA*5
1500	WRITE(11,2000)JCHEM,JB,I,(DTEMP(JCHEM,IA,I),IA=JB,JE)
2000	FORMAT(' CHEM,JB,I,DT',3I3,5E11.3)	
	DO 1700 JA = 1,3
	JB = ((JA-1)*5)+1
	JE = JA*5
1700	WRITE(11,1800)JCHEM,JB,I,(AG(JCHEM,IA,I),IA=JB,JE)
1800	FORMAT(' CHEM,JB,I,AG',3I3,5E11.3)	
3000	CONTINUE
	DO 4000 IA=1,25
4000	WRITE(11,3500)IA,CC(IA,I),CS(IA,I)
3500	FORMAT(' IA,C1,C2',I3,2E11.3)
	WRITE(11,3700)CTEST
3700    FORMAT(' CTEST',E11.3)
C	STOP
	END IF
	IF((TDT.GT.0.0).AND.(TNT.GT.0.0)) THEN
		TEMP(I) = TNT/TDT
	ELSE
		TEMP(I) = DTEMP(1,NC(I),I)
	END IF
C ** END TEST
175	CONTINUE
	RETURN
	END
