         program failedgrid
c failed grid for high luminosity 
c modified for OH5 grains root,capv
         character*5 switch
         character*15 whyskip
         character*19 rootdir
         character*4 arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8,
     &      arg9,arg10,arg11,arg12,arg13
        logical mantles
        integer ips,il1,il2,it1,it2,it3,ior1,ior2,ior3,
     &    iav1,iav2,iir1,iir2
        dimension powergd(5),alumgd1(3),alumgd2(5),tefgd1(6)
        dimension tefgd2(2),tefgd3(2),outrgd1(3),outrgd2(5)
        dimension outrgd3(1),avgd1(3),avgd2(4),ainrgd1(3)
        dimension ainrgd2(6)
c        data powergd/1.5,1.5,1.5,1.5,1.5/
c        data powergd/0.5,0.5,0.5,0.5,0.5/
c         data powergd/0.0,0.0,0.0,0.0,0.0/
         data powergd/1.0,1.0,1.0,1.0,1.0/
c        data powergd/2.0,2.0,2.0,2.0,2.0/
        data alumgd1/1.0,3.0,5.0/
        data alumgd2/1.0,2.0,3.0,4.0,5.0/
        data tefgd1/1.0,2.0,3.0,4.0,5.0,7.0/
        data tefgd2/0.0,5.0/
        data tefgd3/3.0,4.0/
        data outrgd1/1.0,3.0,5.0/
        data outrgd2/4.0,5.0,6.0,7.0,8.0/
        data outrgd3/1.0/
        data avgd1/1.0,3.0,5.0/
        data avgd2/0.0,1.0,2.0,3.0/
        data ainrgd1/1.0,3.0,5.0/
        data ainrgd2/3.0,4.0,5.0,6.0,7.0,8.0/
C *** begin mini-grid
c        dimension powergd(1),alumgd1(1),alumgd2(2),tefgd1(1)
c        dimension tefgd2(1),tefgd3(1),outrgd1(3),outrgd2(1)
c        dimension outrgd3(1),avgd1(3),avgd2(4),ainrgd1(1)
c        dimension ainrgd2(3)
c        data powergd/1.5/
c        data alumgd1/1.0/
c        data alumgd2/2.0,3.0/
c        data tefgd1/5.0/
c        data tefgd2/0.0/
c        data tefgd3/3.0/
c        data outrgd1/1.0,3.0,5.0/
c        data outrgd2/8.0/
c        data outrgd3/1.0/
c        data avgd1/1.0,3.0,5.0/
c        data avgd2/0.0,1.0,2.0,3.0/
c        data ainrgd1/1.0/
c        data ainrgd2/4.0,5.0,6.0/
        rootdir = 'envelope/wisrf/OH5/'
        open(unit=11,file='flowpart.dat',type='unknown')
        open(unit=12,file='directory.dat',type='unknown')
        read(11,*)nf,nfreq,ntcrek
        read(11,*)strms,teff,rstar,abh,abhe
        read(11,*)irorun,power,dens,dmdt,r1,r2
        read(11,*)i1,i2,i3,mantles,rmantle,tice
        rewind(11)
        ips = 1
        il1 = 1
        il2 = 1
        it1 = 1
        it2 = 1
        it3 = 1
        ior1 = 1
        ior2 = 1
        ior3 = 1
        iir1 = 1
        iir2 = 1
        iav1 = 1
        iav2 = 1
        switch = ' go '
        call getarg(1,arg1)
        call getarg(2,arg2)
        call getarg(3,arg3)
        call getarg(4,arg4)
        call getarg(5,arg5)
        call getarg(6,arg6)
        call getarg(7,arg7)
        call getarg(8,arg8)
        call getarg(9,arg9)
        call getarg(10,arg10)
        call getarg(11,arg11)
        call getarg(12,arg12)
        call getarg(13,arg13)
        read(arg1,'(I2)'),ips
        read(arg2,'(I2)'),il1
        read(arg3,'(I2)'),il2
        read(arg4,'(I2)'),it1
        read(arg5,'(I2)'),it2
        read(arg6,'(I2)'),it3
        read(arg7,'(I2)'),ior1
        read(arg8,'(I2)'),ior2
        read(arg9,'(I2)'),ior3
        read(arg10,'(I2)'),iav1
        read(arg11,'(I2)'),iav2
        read(arg12,'(I2)'),iir1
        read(arg13,'(I2)'),iir2
        sollum = alog10(3.826E33)
        sigma  = 5.66E-5
        pi     = 3.1415926
C Use capv = 217.687 for MRN (no ice) 
C Use capv = 210.5 for OH5 (with ice) 
C Use capv = 210.5 for OH2 (no ice)
c        capv   = 217.687
        capv   = 210.5
        power = powergd(ips)
        alum1 = alumgd1(il1)
        alum2 = alumgd2(il2)
        alum  = alum1*(10.00**alum2)
        tef1  = tefgd1(it1)
        tef2  = tefgd2(it2)
        tef3 =  tefgd3(it3)
        teff =  (tef1+0.1*tef2)*(10.00**(tef3))
        alt = alog10(alum)+sollum-(4.0*alog10(teff))
        rstar = sqrt(10.0**(alt)/(4.0*pi*sigma))
        outr1  =  outrgd1(ior1)
        outr2  =  outrgd2(ior2)
        outr3  =  outrgd3(ior3)
        r2   = outr1*10.00**(10.0*outr3+outr2)
        av1    =  avgd1(iav1)
        av2    =  avgd2(iav2)
        av     = av1*(10.00**av2)
        air1   =  ainrgd1(iir1)
        air2   =  ainrgd2(iir2)
        r1   = air1*10.00**(10.0+air2)
        if(power.eq.1.0)then
           arr = power*alog10(r2)+alog10(alog(r2)-alog(r1))
           arr = 10.00**(arr)
        else
           arr =r1*(r2/r1)**power*((r2/r1)**(-power+1.0)-1.0)
     &          /(-power+1.0)
        end if
        dens = av/(1.0857*capv*arr)
        ntcrek = 15
        write(6,*)ips,il1,il2,it1,it2,it3,ior1,ior2,ior3,iav1,
     &    iav2,iir1,iir2,switch
        write(6,560)rootdir,power,alum,teff,r2,av,r1
        write(12,560)rootdir,power,alum,teff,r2,av,r1
 560    format(A19,'D-',F3.1,'/L',1PE8.2,'/T',1PE8.2,'/O',1PE8.2,
     &       '/A',1PE8.2,'/I',1PE8.2)
        write(11,*)nf,nfreq,ntcrek
        write(11,*)strms,teff,rstar,abh,abhe
        write(11,*)irorun,power,dens,dmdt,r1,r2
        write(11,*)i1,i2,i3,mantles,rmantle,tice
        write(11,*)ips,il1,il2,it1,it2,it3,ior1,ior2,ior3,iav1,
     &    iav2,iir1,iir2,switch
        close(11)
        close(12)
        stop
        end




