	SUBROUTINE RDNCOM(TMELT,TGAS,REFF,RDE)
C  THIS ONE FINDS THE GRAIN DESTRUCTION RADIUS GIVEN
C    TMELT  = GRAIN MELTING TEMPERATURE
C    REFF   = EFFECTIVE RADIUS OF PROTOSTELLAR CORE
C    TGAS   = EFFECTIVE TEMPERATURE OF PROTOSTELLAR CORE
	DIMENSION CAP(150),CSCA(150)
	DIMENSION DCACA(150,25),DCASA(150,25)
	COMMON/NNN/NC(200),NS(200),DENS,NCSAV,NSSAV
	COMMON/DUST4/DCAPCA(150,25,200),DCAPSA(150,25,200),DTEMP(2,25,200),
     1	             DPLNK(2,25,200),CHIJ(2,25,200)
	NS(1) = 25
	NC(1) = 25
	DO 557 I=1,25
	DTEMP(1,I,1) = TMELT
	DTEMP(2,I,1) = TMELT
557	CONTINUE
	IRADTR = 0
	CALL GOPAC(TMELT,CAP,CSCA,DCACA,DCASA,1)
	EMMIS = DPLNK(1,12,1)
	DO 77 I=1,25
	DTEMP(1,I,1) = TGAS
	DTEMP(2,I,1) = TGAS
77	CONTINUE
	IRADTR = 0
	CALL GOPAC(TGAS,CAP,CSCA,DCACA,DCASA,1)
	ABSOR = DPLNK(1,12,1)
	RDE = SQRT((REFF**2)*ABSOR/(4.0*EMMIS))*
     -       (TGAS/TMELT)**2
	END
