	SUBROUTINE READIN
	COMMON/QUES/QEXT(150,100,2),QSCA(150,100,2),QPR(150,100,2)
        COMMON/QICE/QICEXT(150,100,2),QICSCA(150,100,2),QICPR(150,100,2)
	COMMON/REAL/HZORSQ,TEFF
	COMMON/PHREQ/NF,FREQ(150),WF(150)
	COMMON/WTS/AC(25),CC(25,200),CS(25,200),CONST(2,25)
	COMMON/NNN/NC(200),NS(200),DENS,NCSAV,NSSAV
	COMMON/ALAM/ALAMDA(83),ASTEPC,ASTEPSI,QASI(100),QAC(100)
  	COMMON/GDIST/ROG(2),AG(2,25,200),AN(2,25,200),W(2,25,200)
	COMMON/REAL3/ABH,ABHE,EL
	COMMON/DUST2/GMIE(150,200),RSTAR,DCASC(150,200)
	COMMON/PICH/PI,C,AMH,UH,ENH
	COMMON/ARE/REFF
	DIMENSION CAN(25,200),SIAN(25,200),ICHAN(2),C1(25),C2(25)
c	DIMENSION AS(25),YC1(25),YSI1(25)
        COMMON/SILICATE/AS(25),YC1(25),YSI1(25)  
C   AC = INITIAL GRAPHITE GRAIN SIZES (MICRONS)
C   AS = INITIAL SILICATE GRAIN SIZES (MICRONS)
c to alter the boundary conditions for grain sizes RDCOM.FOR.  
c talk to MGW first.
c	DATA AC/0.005,0.006,0.009,0.011,
c     A  0.015,0.020,0.026,0.035,0.046,0.061,0.081,0.100,0.143,0.189,
c     B  0.25/	
c	DATA AS/0.005,0.006,0.009,0.011,
c     A  0.015,0.020,0.026,0.035,0.046,0.061,0.081,0.100,0.143,0.189,
c     B  0.25/	
C   ALAMDA = WAVELENGTHS (MICRONS) USED IN GOPAC AND TRANSFER
       DATA ALAMDA/.09118,0.11175,0.13695,0.17199,0.216,0.27126,
     A  0.3406,0.4350,0.5555,0.7253,0.9469,1.25,1.650,1.90533,2.20,
     A  2.36629,2.54527,2.73772,2.945,3.13049,3.32772,3.53739,
     B  3.76,3.9967,4.24827,4.5157,4.80,5.08785,5.393,5.71542,6.057,
     B  6.4242,6.8136,
     B   7.2267,7.6648,8.12934,
     C  8.6225,8.88043,9.14539,9.41825,9.7,9.8951,
     C  10.0940,10.2969,10.505,10.7159,10.9312,11.1510,11.376,
     C  12.0,12.658,14.161,15.844,16.8880,18.0,19.1862, 20.449,
     C   22.610,25.0,31.117,
     D  38.731,48.208,60.0,68.173,77.46,88.011,100.0,112.20,
     D  125.889,141.252,158.490,
     D  177.830,199.531,223.875,
     D  251.189,316.227,398.099,
     E  501.119,630.944,794.311,1000.0,1732.01,3000.0/
        PI = 3.1415926
	C = 2.997925E+10
	AMH = 1.67E-24
	UH = (ABH+4.0*ABHE)/ABH
	ENH = 1.0/(UH*AMH)
C   ROG = BULK MASS OF GRAIN MATERIAL
	ROG(1) = 2.26
        ROG(2) = 3.3
	OPEN(UNIT=15,STATUS='OLD',FILE='rqextoh2.dat')
	OPEN(UNIT=16,STATUS='OLD',FILE='rscatoh2.dat')
	OPEN(UNIT=17,STATUS='OLD',FILE='rqprtoh2.dat')
        OPEN(UNIT=18,STATUS='OLD',FILE='rqextoh5.dat')
        OPEN(UNIT=19,STATUS='OLD',FILE='rscatoh5.dat')
        OPEN(UNIT=20,STATUS='OLD',FILE='rqprtoh5.dat')
C   GRAIN SIZE DISTRIBUTION EQUAL STEPS IN LOG a
        A1 = ALOG10(0.095)
        A25 = ALOG10(0.105)
        STEP = (A25-A1)/24.0
        DO 50 IA=1,25
        AC(IA) = 10.0**(A1+FLOAT(IA-1)*STEP)
        AS(IA) = AC(IA)
c        WRITE(6,*)'IA,AC,AS',IA,AC(IA),AS(IA)
50      CONTINUE
C   GRAIN NUMBER DISTRIBUTION (NUMBER/H-ATOM/MICRON)
	DO 100 NR = 1,200
	DO 100 M=1,25
C    GALACTIC VALUES which force Kappa (cm^2 / gm of gas) to give
C    Ossenkopf and Henning  (cm^2/ gm of dust)/100.0     
C    Assume single grain type and silicates = 0 (so that
C    grain evaporation does not affect opacity). 
C    Cgraphite  = -13.0975
C    log (#/H-atom-micron)
C    
	CAN(M,1)  = -13.0975-(3.5*ALOG10(AC(M)))
	SIAN(M,1) = -25.0000-(3.5*ALOG10(AS(M)))
C    LOAD  GRAIN SIZE ARRAYS
	AG(1,M,NR) = AC(M)
	AG(2,M,NR) = AS(M)
C    BIN NUMBER OF LARGEST INWARD FLOWING GRAIN
	NC(NR) = 25
	NS(NR) = 25
100	CONTINUE	
C     READ OPTICAL EFFICIENCIES 
	DO 200 K=1,2
	DO 200 J=1,100
	DO 125 L=1,10
	M = L*8
	READ(15,300)(QEXT(I,J,K),I=M-7,M)
        READ(18,300) (QICEXT(I,J,K),I=M-7,M)
125	CONTINUE
	READ(15,600) (QEXT(I,J,K),I=81,83)
        READ(18,600) (QICEXT(I,J,K),I=81,83)
	DO 150 L=1,10
	M=L*8
	READ(16,300)(QSCA(I,J,K),I=M-7,M)
	READ(19,300)(QICSCA(I,J,K),I=M-7,M)
150	CONTINUE
	READ(16,600) (QSCA(I,J,K),I=81,83)
	READ(19,600) (QICSCA(I,J,K),I=81,83)
	DO 175 L=1,10
	M=L*8
	READ(17,300)(QPR(I,J,K),I=M-7,M)
	READ(20,300)(QICPR(I,J,K),I=M-7,M)
175	CONTINUE	
	READ(17,600) (QPR(I,J,K),I=81,83)
	READ(20,600) (QICPR(I,J,K),I=81,83)
200	CONTINUE
300	FORMAT(8E11.3)
600	FORMAT(3E11.3) 
	READ(15,*)ASTEPC,ASTEPSI
	DO 325 L=1,100
	READ (15,*)QAC(L),QASI(L)
325	CONTINUE
C    EVALUATE FREQUENCY INTEGRATION CONSTANTS
C    NOTE THAT GROUPS OF 3 FREQUENCIES MUST BE EQUALLY SPACED
C    IN LOG (NU) 
C    INTEGRALS = INTEGRAL( X * NU d(lnNU) )
	DO 375 L=1,NF
	I = NF-L+1
	FREQ(I) = (2.997925E+14/ALAMDA(L))
	WRITE(6,*)'I,FREQ',I,FREQ(I)
375	CONTINUE
	DO 400 I=2,NF-1,2
	DELN = ALOG(FREQ(I))-ALOG(FREQ(I-1))
400	WF(I) = 4.0*DELN/3.0
	WF(1) = WF(2)/4.0
	WF(NF) = WF(NF-1)/4.0
	DO 425 I=3,NF-2,2
425	WF(I) = (WF(I-1)+WF(I+1))/4.0
	DO 450 I=1,NF
450	WRITE(6,*)'I,WF',I,WF(I)
C   EVALUATE NUMBER ABUNDANCE INTEGRATION CONSTANTS
	DO 500 NR = 1,200
	DO 500 M=2,25
	CC(M-1,NR) = 0.5*((10.00**CAN(M,1))+(10.00**CAN(M-1,1)))
	CS(M-1,NR) = 0.5*((10.00**SIAN(M,1))+(10.00**SIAN(M-1,1)))
500	CONTINUE
C     FIND INITIAL GRAIN TO GAS MASS RATIO 	
	DO 525 M=2,25
	AVEC = (AG(1,M,1)+AG(1,M-1,1))*0.5
	AVES = (AG(2,M,1)+AG(2,M-1,1))*0.5
	YC1(M-1) = PI*4.0*(AVEC**3)*ENH
     1             *ROG(1)*1.0E-12/3.0
	YSI1(M-1) = PI*4.0*(AVES**3)*ENH
     2             *ROG(2)*1.0E-12/3.0
	C1(M-1) = CC(M-1,1)
	C2(M-1) = CS(M-1,1)
525	CONTINUE	
	CALL TWOTEG2(AC,YC1,ALMGC0,25,C1,AS,YSI1,ALMGS0,25,C2)
	WRITE(6,*)'ALMGC0,ALMGS0 = ',ALMGC0,ALMGS0
C   FIND EFFECTIVE RADIUS WHICH WILL REDISTRIBUTE ALL RADIATION SHORTWARD
C   OF LYMAN LIMIT
	T2 = TEFF**2
	SIG = 5.66956E-5
	CALL BINT(TEFF,BB)
	REFF = T2*RSTAR*SQRT(SIG/BB)
	WRITE(6,*)'REFF =',REFF
	CLOSE (15)
	CLOSE (16)
	CLOSE (17)
        CLOSE (18)
        CLOSE (19)
        CLOSE (20)
	RETURN
	END

