 	SUBROUTINE READRO(R,T,RO)
c  modified to read in all dust temperatures - and <T_Si>
c  density is recalculated by analytic formula
        COMMON/REAL/ HZORSQ,TEFF
	COMMON/CORE/STRMS,STARL
        COMMON/INTRG/  II,III,NFREQ
        COMMON/DUST2/GMIE(150,200),RSTAR,DCASC(150,200)
        COMMON/DUST4/DCAPCA(150,25,200),DCAPSA(150,25,200),
     1         DTEMP(2,25,200),DPLNK(2,25,200),DCHIJ(2,25,200)
C  control for ice mantles  (DOSW 7/27/87)
        COMMON/DUST6/MANTLES,RMANTLE,TICE
        COMMON/MINDEX/ips,il1,il2,it1,it2,it3,ior1,ior2,ior3,iav1,
     &    iav2,iir1,iir2 
        COMMON/CASES/ ITER, NTCREK
        LOGICAL MANTLES
	DIMENSION R(200),T(200),RO(200),RINT(200),ROINT(200),
     &     DTEMINT(2,25,200),DTEM(200),TINT(200)
	YEAR = 60.*60.*24.*365.24
        ALSUN = ALOG10(3.826E33)
        PI    = 3.1415926
        READ(10,*)IRORUN,POWER,DENS,DMDT,R1,R2
        READ(10,*)I1,I2,I3,MANTLES,RMANTLE,TICE
        READ(10,*)ips,il1,il2,it1,it2,it3,ior1,ior2,ior3,iav1,
     &    iav2,iir1,iir2
        WRITE(11,1000)IRORUN,POWER,DENS,DMDT,R2,I1,I2,I3,
     .   MANTLES,RMANTLE,TICE 
        WRITE(23,1000)IRORUN,POWER,DENS,DMDT,R2,I1,I2,I3,
     .   MANTLES,RMANTLE,TICE 
 1000   FORMAT('IRORUN = ',I5/'POWER = ',F6.4/'DENS = ',E12.4/
     .         'DMDT = ',E12.4/'R2 = ',E12.4/,'I1 = ',I5/,'I2 = ',
     .          I5/'I3 = ',I5/'MANTLES = ',L3/'RMANTLE = ',E12.4/
     .         'TICE = ',E12.4)
	DMDT = DMDT*1.989E33/YEAR
	WRITE(6,*)'DMDT =',DMDT
	WRITE(6,*)'MASS =',STRMS
        NTCREK = 1
C These values, I1, I2 and I3 may be changed to reduce the length
c of the computations if reducing them does not cause a significant
c error in the flux conservation.  Check to see that the region where
c the temperature is changing the most has a higher density of grid
c points.
c Typical vaules might be:
c	I1 = 46
c	I2 = 42
c	I3 = 30 

C Open data file for flowm2.f R grid parameters
        OPEN(UNIT=51,STATUS='OLD',FILE='rgrid.dat')
        READ(51,*)IADDI2,IADDI3,RI3,IDEL1,IDEL2
        CLOSE(51)
c         I2 = I2 + 75
c         I2 = I2 - 30
c         I3 = I3 + 75
         I2 = I2 + IADDI2
         I3 = I3 + IADDI3
	III = I1+I2+I3
	II = III-1

        OPEN(UNIT=50,STATUS='OLD',FILE='totmod.out')
        READ(50,*)IIIMAX
C Corrected boo boo here to allow for increases in I1 and I2
c Nope IIIMAX is maximum from flowm. III is different maximum 
c for flomwout
c        IIIMAX = III
        DO 10 I=1,IIIMAX
        READ(50,*)RINT(I),TINT(I),
     &               (DTEMINT(1,IA,I),IA=1,25)
 10     CONTINUE
        DO 30 I=1,IIIMAX
        READ(50,*)(DTEMINT(2,IA,I),IA=1,25)
 30     CONTINUE
C GRID PARAMETERS:
c        RI3=1.01
c        RI3 = 0.9
        RMELT = RINT(1)
C Equal steps in ln R
        IF (IDEL1.EQ.1) THEN
           STEP = (ALOG(RI3*R2)-ALOG(RMELT))/(I1+I2-1)
        END IF
C Equal steps in 1/R 
        IF (IDEL1.EQ.2) THEN
           IF (RI3.GT.1.0) THEN
  	      STEP = (1.0/(RMELT)-(1.0/(RI3*RMELT)))/(I1+I2-1)
           ELSE 
              STEP = (1.0/(RMELT)-(1.0/(RI3*R2)))/(I1+I2-1)
           ENDIF
        ENDIF
	DO 5 I=1,I1+I2
C Equal steps in ln R
        IF (IDEL1.EQ.1) THEN
           R(I) = EXP(ALOG(RMELT)+(I-1)*STEP)
        END IF
C Equal steps in 1/R 
        IF (IDEL1.EQ.2) THEN
           ETA = (1.0/(RMELT))-((I-1)*STEP)
	   R(I) = 1/ETA
        END IF
        IF(IRORUN.EQ.1) RO(I) = DENS
        IF(IRORUN.EQ.2) RO(I) = DENS*(R2/R(I))**POWER
        if(i.gt.1)delror = (r(i)-r(i-1))*(ro(i)+ro(i-1))*0.5
        CALL INTERP(RINT,TINT,IIIMAX,2,R(I),T(I))
	WRITE(6,*)'R,T,RO',I,R(I),T(I),RO(I),delror
 5      CONTINUE
C Equal steps in ln R
        IF (IDEL2.EQ.1) THEN
           IF (RI3.GT.1.0) THEN
              STEP = (ABS(ALOG(R2)-ALOG(RI3*RMELT)))/I3
           ELSE
              STEP = (ABS(ALOG(R2)-ALOG(RI3*R2)))/I3
           END IF
        END IF
C Equal steps in 1/R 
        IF (IDEL2.EQ.2) THEN
           IF (RI3.GT.1.0) THEN
              STEP = (1.0/(RI3*RMELT)-(1.0/(R2)))/(I3)
            ELSE
              STEP = (1.0/(RI3*R2)-(1.0/(R2)))/(I3)
            END IF
         END IF
C Equal steps in R
        IF (IDEL2.EQ.3) THEN
           IF (RI3.GT.1.0) THEN
              STEP = (R2-(RI3*RMELT))/(I3)
           ELSE
              STEP = (R2-(RI3*R2))/(I3)
           END IF
        END IF
	DO 50 I=2,I3+1
	J= I1 + I2 + I -1
C Equal steps in ln R
        IF (IDEL2.EQ.1) THEN
           R(J) = exp(ALOG(R(I1+I2))+((I-1)*STEP))
        END IF
C Equal steps in 1/R 
        IF (IDEL2.EQ.2) THEN
           ETA = (1.0/(R(I1+I2)))-((I-1)*STEP)
            R(J) = 1/ETA
        END IF
C Equal steps in R
         IF (IDEL2.EQ.3) THEN
            R(J) = R(I1+I2) + ((I-1)*STEP)
         END IF      
        IF(IRORUN.EQ.1) RO(J) = DENS
        IF(IRORUN.EQ.2) RO(J) = DENS*(R2/R(J))**POWER
        CALL INTERP(RINT,TINT,IIIMAX,2,R(J),T(J))
        if(j.gt.1)delror = (r(j)-r(j-1))*(ro(j)+ro(j-1))*0.5
	WRITE(6,*)'R,T,RO',J,R(J),T(J),RO(J),delror
50	CONTINUE
	WRITE(6,*)'III = ',III
200	CONTINUE
        DO 300 ICHEM=1,2
        DO 300 IA=1,25
        DO 250 I=1,IIIMAX
        DTEM(I) = DTEMINT(ICHEM,IA,I)
 250    CONTINUE
        DO 275 I=1,III
        CALL INTERP(RINT,DTEM,IIIMAX,2,R(I),DTEMP(ICHEM,IA,I))
 275    CONTINUE
 300    CONTINUE
	RETURN
	END 









