 	SUBROUTINE READRO(R,T,RO)
c  modified to ask for R2 (dosw)
        COMMON/REAL/ HZORSQ,TEFF
	COMMON/CORE/STRMS,STARL
        COMMON/INTRG/  II,III,NFREQ
        COMMON/DUST2/GMIE(150,200),RSTAR,DCASC(150,200)
	COMMON/DUST4/DCAPCA(150,25,200),DCAPSA(150,25,200),DTEMP(2,25,200),
     1	             DPLNK(2,25,200),DCHIJ(2,25,200)
C  control for ice mantles  (DOSW 7/27/87)
        COMMON/DUST6/MANTLES,RMANTLE,TICE
        COMMON/MINDEX/ips,il1,il2,it1,it2,it3,ior1,ior2,ior3,iav1,
     &    iav2,iir1,iir2 
        LOGICAL MANTLES
	DIMENSION R(200),T(200),RO(200)
        DIMENSION AVGD1(3),AVGD2(4)
        DATA AVGD1/1.0,3.0,5.0/
        DATA AVGD2/0.0,1.0,2.0,3.0/
	YEAR = 60.*60.*24.*365.24
        ALSUN = ALOG10(3.826E33)
        PI    = 3.1415926
        READ(10,*)IRORUN,POWER,DENS,DMDT,R1,R2
        READ(10,*)I1,I2,I3,MANTLES,RMANTLE,TICE
        READ(10,*)ips,il1,il2,it1,it2,it3,ior1,ior2,ior3,iav1,
     &    iav2,iir1,iir2
        WRITE(11,1000)IRORUN,POWER,DENS,DMDT,R2,I1,I2,I3,
     .   MANTLES,RMANTLE,TICE 
        WRITE(23,1000)IRORUN,POWER,DENS,DMDT,R2,I1,I2,I3,
     .   MANTLES,RMANTLE,TICE 
 1000   FORMAT('IRORUN = ',I5/'POWER = ',F6.4/'DENS = ',E12.4/
     .         'DMDT = ',E12.4/'R2 = ',E12.4/,'I1 = ',I5/,'I2 = ',
     .          I5/'I3 = ',I5/'MANTLES = ',L3/'RMANTLE = ',E12.4/
     .         'TICE = ',E12.4)
	DMDT = DMDT*1.989E33/YEAR
	WRITE(6,*)'DMDT =',DMDT
	WRITE(6,*)'MASS =',STRMS
	VCON = SQRT(2.0*STRMS*6.68E-8)*SQRT(1.989E+33)
	VCON = DMDT/(VCON*4.0*3.1415926)

C These values, I1, I2 and I3 may be changed to reduce the length
c of the computations if reducing them does not cause a significant
c error in the flux conservation.  Check to see that the region where
c the temperature is changing the most has a higher density of grid
c points.
c Typical vaules might be:
c	I1 = 46
c	I2 = 42
c	I3 = 30

C Open data file for flowm.f R grid parameters
        OPEN(UNIT=51,STATUS='OLD',FILE='rgrid.dat')
        READ(51,*)IADDI2,IADDI3,RI3,IDEL1,IDEL2
        CLOSE(51)

c         I2 = I2  + 75
c         I2 = I2 - 30
c         I3 = I3 + 75
         I2 = I2 + IADDI2
         I3 = I3 + IADDI3
	III = I1+I2+I3
	II = III-1

C    GUESS OF GRAIN TEMPERATURE AT OUTER EDGE
	TZERO = 10.0
C    GUESS OF GRAIN MELTING TEMP
c	TMELT = 1500.0
        TMELT = 700.0
c        TMELT = 100.0
C    FIND DESTRUCTION RADIUS
C  Destruction radius is the balance between radiative heating by stellar
c  field and radiative cooling.
        IF(R1.LT.0.0)THEN
           CALL RDNCOM(TMELT,TEFF,RSTAR,RMELT)	
        ELSE 
            RMELT = R1
        END IF
        TMELT = 1200.0*((STARL/1.0E3)**(1.0/4.0))/SQRT(RMELT/1.0E14)
        WRITE(23,*)'RIN =  ',RMELT
c	ALPH = ALOG10(TMELT/TZERO)/ALOG10(RMELT/R2)
        ALPH = -0.40
	WRITE(6,*)'R2,RMELT,ALPH,TMELT',R2,RMELT,ALPH,TMELT
C    EQUAL STEPS IN 1/R FROM INNER EDGE TO RI2*INNER EDGE
C GRID PARAMETERS:
C CONVERT INDICES INTO PHYSICAL VALUES
        AV = avgd1(iav1)*(10.00**avgd2(iav2))

c RI3    = multiplier to end zone 1 and begin zone 2
c         For RI3 > 1 The first zone extends to RI3 x RMELT
c         For RI3 < 1 The first zone extends to RI3 x R_outer
c IDEL1  = 1 then equal steps in ln R
c        = 2 then equal steps in 1/R
c IDEL2  = 1 then equal steps in ln R
c         = 2 then equal steps in 1/R
c         = 3 then equal steps in linear R

c        RI3 = 0.9
c        IDEL1 = 2
c        IDEL2 = 2

C Equal steps in ln R
        IF (IDEL1.EQ.1) THEN
           STEP = (ALOG(RI3*R2)-ALOG(RMELT))/(I1+I2-1)
        END IF
C Equal steps in 1/R 
        IF (IDEL1.EQ.2) THEN
           IF (RI3.GT.1.0) THEN
  	      STEP = (1.0/(RMELT)-(1.0/(RI3*RMELT)))/(I1+I2-1)
           ELSE 
              STEP = (1.0/(RMELT)-(1.0/(RI3*R2)))/(I1+I2-1)
           ENDIF
        ENDIF
	DO 5 I=1,I1+I2
C Equal steps in ln R
        IF (IDEL1.EQ.1) THEN
           R(I) = EXP(ALOG(RMELT)+(I-1)*STEP)
        END IF
C Equal steps in 1/R 
        IF (IDEL1.EQ.2) THEN
           ETA = (1.0/(RMELT))-((I-1)*STEP)
	   R(I) = 1/ETA
        END IF
        IF(IRORUN.EQ.1) RO(I) = DENS
        IF(IRORUN.EQ.2) RO(I) = DENS*(R2/R(I))**POWER
        if(i.gt.1)delror = (r(i)-r(i-1))*(ro(i)+ro(i-1))*0.5
	T(I) = TMELT*(R(I)/RMELT)**ALPH
        IF(T(I).LT.15.0)T(I)=15.0
	WRITE(6,*)'R,T,RO',I,R(I),T(I),RO(I),delror
 5      CONTINUE
C Equal steps in ln R
        IF (IDEL2.EQ.1) THEN
           IF (RI3.GT.1.0) THEN
              STEP = (ABS(ALOG(R2)-ALOG(RI3*RMELT)))/I3
           ELSE
              STEP = (ABS(ALOG(R2)-ALOG(RI3*R2)))/I3
           END IF
        END IF
C Equal steps in 1/R 
        IF (IDEL2.EQ.2) THEN
           IF (RI3.GT.1.0) THEN
              STEP = (1.0/(RI3*RMELT)-(1.0/(R2)))/(I3)
            ELSE
              STEP = (1.0/(RI3*R2)-(1.0/(R2)))/(I3)
            END IF
         END IF
C Equal steps in R
        IF (IDEL2.EQ.3) THEN
           IF (RI3.GT.1.0) THEN
              STEP = (R2-(RI3*RMELT))/(I3)
           ELSE
              STEP = (R2-(RI3*R2))/(I3)
           END IF
        END IF
	DO 50 I=2,I3+1
	J= I1 + I2 + I -1
C Equal steps in ln R
        IF (IDEL2.EQ.1) THEN
           R(J) = exp(ALOG(R(I1+I2))+((I-1)*STEP))
        END IF
C Equal steps in 1/R 
        IF (IDEL2.EQ.2) THEN
           ETA = (1.0/(R(I1+I2)))-((I-1)*STEP)
            R(J) = 1/ETA
        END IF
C Equal steps in R
         IF (IDEL2.EQ.3) THEN
            R(J) = R(I1+I2) + ((I-1)*STEP)
         END IF      
        T(J) = TMELT*(R(J)/RMELT)**ALPH
        IF(T(J).LT.15.0)T(J)=15.0
	RO(J) = VCON/(R(J)**1.5)
	IF(IRORUN.EQ.1) RO(J) = DENS
        IF(IRORUN.EQ.2) RO(J) = DENS*(R2/R(J))**POWER
        if(j.gt.1)delror = (r(j)-r(j-1))*(ro(j)+ro(j-1))*0.5
	WRITE(6,*)'R,T,RO',J,R(J),T(J),RO(J),delror
50	CONTINUE
	J = 0
	WRITE(6,*)'III = ',III
	DO 200 I=1,III
	DO 200 IA = 1,25
	DO 200 ICHEM = 1,2
	DTEMP(ICHEM,IA,I) = T(I)
200	CONTINUE
	RETURN
	END 




