        SUBROUTINE SPHDUST(N,S,CHI,AVJ,AVH,AVK)
        DOUBLE PRECISION TAU,R1,R0,H1,H0
        DOUBLE PRECISION AIPLUS,A,B
c        REAL MU0,MU1
       DOUBLE PRECISION MU0,MU1,AH,BH,D1,D2,D3
        LOGICAL SYM
        INTEGER PNDEXX,PINDEX
        COMMON/BIGS/ XJNU(150,200),XHNU(150,200),FKJ(150,200),FHJ(150),
     A             QSP(150,200),HHNU(150)
        COMMON/OPTDEP/ TAUZ(200),CAPZER
        COMMON/PHREQ/ NF,FREQ(150),WF(150)
        COMMON/IMPACT/ TERP(200),NUED,IIIED
        COMMON/RADGRD/RDIR(300),NPSP,PPX(200),PNDEXX(200)
        COMMON/FRAC/P(200),R(300),NR,NP,PINDEX(200)
        COMMON/EDFCTR/ FH,FK(200)
        COMMON/INTRG/ II,III,NFREQ
        COMMON/CASES/ ITER,NTCREK
        COMMON/FFR/NTCRR
        COMMON/DUST3/STRFLD(200),TAUNU(200),PTHAU(200)
        COMMON/CONT/AIPLUS(150,200),AIMPCT(200)
        COMMON/ARE/REFF
C   STRFLD = Lnu(star)*EXP(-PTHAU)/(4*PI*R**2)
C          = The Stellar Contibution to J,H,K at R
        DIMENSION CHI(200),S(200),AVJ(200),AVH(200),AVK(200),YPR(200)
        DIMENSION SM(200),TAU(200),AVHBC(200)
        COMMON/BLANK2/ R1(200),R0(200),H0(200),H1(200),MU0(200),MU1(200)
        FRFRI = 0.0
C Subroutine to get ISRF for I-
        CALL ISRFSUB(FREQ(NUED),NUED,AIMINUS)
        BCINWRD = AIMINUS
        M=PNDEXX(1)-III
        MP=M+1
        DO 1 I=MP,NPSP
        IMP=PNDEXX(I)
        AVJ(I)=0.
        AVH(I)=0.
        AVHBC(I)=0.
        AVK(I)=0.
        MU1(IMP)=1.
1       CONTINUE
C
C   RAY GOING THROUGH THE CENTER
C   R is U in notes
C   H is V in notes
        Y=0.0
        CALL TCOMPD(Y,RDIR,CHI,TAU,N)
        BC = 0.0
        SYM = .TRUE.
C  FEAUTRIER CALL UP
        CALL SPLRAD(N,TAU,S,R1,H1,BC,BCINWRD,SYM)
C  Output should be background subtracted emission (I+ - I-)
C    If (I+ - I-) is negative it means absorption against background 
C    For I+ use:
C        AIPLUS(NUED,1) = (2.0*H1(1))+BCINWRD
C    For I+ - I- use:
        AIPLUS(NUED,1) = (2.0*H1(1))

        AIMPCT(1) = Y


C  END OF FIRST RAY
C
C  RAY TANGENT TO THE ITH SHELL,  NOTE USE OF THE SYMMETRY PROPERTY
        NPLIM=NPSP
C  DO OVER IMPACT PARAMETERS
        DO 10 IMP=2,NPLIM
        Y=PPX(IMP)
        I=PNDEXX(IMP)
        IF(I.LE.III) GO TO 3

C  IN DUST CASE RAYS THAT HIT CAVITY
C  EXTRA RAYS TO INSURE ACCURACY AT DEPTH
        NN=N
        CALL TCOMPD(Y,RDIR,CHI,TAU,NN)
        BC = 0.0
        SYM = .TRUE.
C  FEAUTRIER CALL UP
        CALL SPLRAD(NN,TAU,S,R0,H0,BC,BCINWRD,SYM)

        GO TO 6
C  END OF RAYS THAT HIT CORE
C
C  RAYS THAT MISS CORE
C  OR IN DUST CASE RAYS THAT ARE FULLY WITHIN THE DUST
C  SHELL (MISS CAVITY)
C  RAY TANGENT TO RDIR(I)
    3   NN=I
        IF(I.EQ.1) GO TO 5
        CALL TCOMPD(Y,RDIR,CHI,TAU,NN)
        IF(I.EQ.2) GO TO 4
        SYM=.TRUE.
        BC=0.
C   FEAUTRIER CALL UP
        CALL SPLRAD(NN,TAU,S,R0,H0,BC,BCINWRD,SYM)
C
        GO TO 6
C
C  SECOND TO LAST RAY
C  SPECIAL TREATMENT FOR I = 2
    4   TAU(3)=2.*TAU(2)-TAU(1)
        N0=3
        SYM=.TRUE.
        BC=0.0
        CALL SPLRAD(N0,TAU,S,R0,H0,BC,BCINWRD,SYM)
        GO TO 6
C
C  LAST RAY
C  RAY TANGENT TO OUTER SHELL
    5   R0(1)=AIMINUS
        H0(1)=0.
C  START ANGLE INTEGRATION
C
    6   JJM=MAX0(MP,IMP)
        DO 9 JJ=JJM,NPSP
        J=PNDEXX(JJ)
C  GET MU VALUES ALONG THE RAY
        MU0(J)=DSQRT(1.-DBLE(Y/RDIR(J))**2)
C  STEP INTEGRATION OF J,H,AND K
        CZ=MU0(J)
        C1=MU1(J)
        A=C1*R0(J)-CZ*R1(J)
        B=R1(J)-R0(J)
        AH=C1*H0(J)-CZ*H1(J)
        BH=H1(J)-H0(J)
        D1=CZ+C1
        D2=C1**2+C1*CZ+CZ**2
        D3=C1**3+C1*C1*CZ+C1*CZ*CZ+CZ**3
        AVJ(JJ)=AVJ(JJ)+SNGL(A+.5*B*D1)
        AVH(JJ)=AVH(JJ)+SNGL(.5*AH*D1+BH*D2/3.)
        AVHBC(JJ)=AVHBC(JJ)+SNGL(0.5*A*D1+B*D2/3.)
        AVK(JJ)=AVK(JJ)+SNGL(A*D2/3.+B*D3/4.)
        MU1(J)=MU0(J)
        R1(J)=R0(J)
        H1(J)=H0(J)
    9   CONTINUE
C  For I+ use:
c        AIPLUS(NUED,IMP) = (2.0*H0(1))+BCINWRD
C  For I+ - I- Use
        AIPLUS(NUED,IMP) = (2.0*H0(1))
        AIMPCT(IMP) = Y
   10   CONTINUE
C  END DO LOOP OVER RAYS

C  FIND EDDINGTON FACTORS FK AND FH
        M=PNDEXX(1)-III
        MP=PNDEXX(1)-III+1
        J=0
        DO 11 IMP=MP,NPSP
        J=J+1
        I = PINDEX(J)
        AVJ(IMP) = AVJ(IMP)+STRFLD(I)
        AVH(IMP) = AVH(IMP)+STRFLD(I)
        AVHBC(IMP) = AVHBC(IMP)+STRFLD(I)
        AVK(IMP) = AVK(IMP)+STRFLD(I)
        FK(J)=AVK(IMP)/AVJ(IMP)
   11   CONTINUE
        FH=AVHBC(NPSP)/AVJ(NPSP)
        NFK=NPSP-M
C      
C  HERE SPLINES ARE USED TO INTERPOLATE TO GET THE EDDINGTON FACTORS AT
C  ALL RADII GIVEN THE EDDINGTON FACTOR FROM SPHERE AT RADII CORESSPONDING
C  TO RAY TANGENTS
C
        FHJ(NUED)=FH
        IDRIV=0
        CALL ONESPL(TERP,FK,SM,YP1,YPN,YPR,NFK,IDRIV)
        DO 60 I=1,IIIED
        M=IIIED-I+1
        AR=ALOG10(TAUZ(M)+1.0E-4)
        FKJ(NUED,I)=SPLEVE(AR,TERP,FK,SM,YP1,YPN,NFK)
	IF(FKJ(NUED,I).GT.1.00) FKJ(NUED,I) = 1.00
	IF(FKJ(NUED,I).LT.0.10) FKJ(NUED,I) = 0.10
	IF(FKJ(NUED,I).LT.0.15) THEN
c        TYPE 57,I,NUED,FKJ(NUED,I),STRFLD(I),S(M),XJNU(NUED,I)
57	FORMAT(' I,NU,F,STRFLD,S,J',2I5,4E11.3)
	END IF
60      CONTINUE
        RETURN
        END


