        SUBROUTINE SPHRSET
        INTEGER PINDEX,PNDEXX
        COMMON/OPTDEP/ TAUZ(200),CAPZER
        COMMON/IMPACT/ TERP(200),NUED,IIIED 
        COMMON/RADGRD/ RDIR(300),NPSP,PPX(200),PNDEXX(200)
        COMMON/FRAC/ P(200),R(300),NR,NP,PINDEX(200)
        COMMON/INTRG/ II,III,NFREQ
        COMMON/ATMSP/TEMP(200),DENST(200)
        DIMENSION OPACT(200)
C   FIND TAUZ FOR INTERPOLATION OF ED FACTOR FKJ FROM ED 
C   FOUND IN SPHERE
        DO 100 I=1,III
100     OPACT(I) = CAPZER
        CALL TAUSCL(OPACT,DENST,R,TAUZ,III)
        J=0
        NIOJ=3
C   NIOJ SETS THE NUMBER OF RADIUS POINTS PER IMPACT RAY
        NCORE = 6
C   NCORE SETS THE NUMBER OF RAYS THAT HIT CORE
        DO 125 I=1,III,NIOJ
        J=J+1
        PINDEX(J)=I
        P(J)=R(I)
        M=III-I+1
C   TERP IS THE OPTICAL DEPTH GRID FOR EDDINGTON FACTOR INTERPOLATION
        TERP(J)=ALOG10(TAUZ(M)+1.0E-4)
125     CONTINUE
        NP=J
        NCOR1=NCORE+1
        NPSP=(III-1)/NIOJ+1+NCORE
        DO 175 I=1,III
        J=III-I+1
175     RDIR(J)=R(I)
        PPX(NPSP)=RDIR(1)
        PNDEXX(NPSP)=1
        IP=NPSP-1
        NIOJ1=NIOJ+1
        DO 200 I=NIOJ1,III,NIOJ
        PPX(IP)=RDIR(I)
        PNDEXX(IP)=I
        IP=IP-1
200     CONTINUE
        ENCR=FLOAT(NCORE)
        XMU=1.
        DXMU=1./FLOAT(NCORE-1)
        DO 225 IP=1,NCORE
        PPX(IP)=RDIR(III)*SQRT(1.-XMU**2)
        XMU=XMU-DXMU
225     PNDEXX(IP)=III+NCOR1-IP
        DO 300 J=1,NPSP
        IX=PNDEXX(J)
        IF(J.LE.NP) GO TO 250
C       WRITE(11,275) PPX(J),J,IX
        GO TO 300
250     I=PINDEX(J)
C        WRITE(11,275) PPX(J),J,IX,P(J),J,I
275     FORMAT(1H ,2(E15.5,2I5,5X))
300     CONTINUE
        RETURN
      END

