	SUBROUTINE DSORCE(I,NU,DCBNU)
C   DSORCE EVALUATES THE INTEGRAL OF CAP*BNU OVER THE
C   SIZE DISTRIBUTION
	COMMON/GDIST/ROG(2),AG(2,25,200),AN(2,25,200),W(2,25,200)
	COMMON/WTS/A(25),CC(25,200),CS(25,200),CONST(2,25)
	COMMON/DUST4/DCAPCA(150,25,200),DCAPSA(150,25,200),DTEMP(2,25,200),
     1	DPLNK(2,25,200),DCHIJ(2,25,200)
	COMMON/NNN/NC(200),NS(200),DENS,NCSAV,NSSAV
	COMMON/PHREQ/NF,FREQ(150),WF(150)
	COMMON/PICH/PI,C,AMH,UH,ENH
	DIMENSION C1(25),C2(25),AC(25),AS(25),Y1(25),Y2(25)
	ENH8 = ENH*1.0E-8
	DO 50 IA=1,25
C   LOAD NUMBER DISTRIBUTION ARRAYS (#/H-ATOM/MICRON)
	C1(IA) = CC(IA,I)
	C2(IA) = CS(IA,I)
C   LOAD GRAIN SIZE ARRAYS (MICRONS)
	AC(IA) = AG(1,IA,I)
	AS(IA) = AG(2,IA,I)
50	CONTINUE
	NX = NC(I)
	FRE = FREQ(NU)
	DO 100 ICHEM = 1,2
	IF(ICHEM.EQ.2) NX = NS(I)
	TX1 = DTEMP(ICHEM,1,I)	
	BNU1 = BNUF(FRE,TX1)
	DO 100 NBIN = 1,NX-1
	IA1 = NBIN
	IA2 = NBIN+1
	TX2 = DTEMP(ICHEM,IA2,I)
	BNU2 = BNUF(FRE,TX2)
C   FIND CAP(FRE,A,L)*BNU(FRE,T(A),L)  NOTE: CAP (MICRON**2/GRAIN)
C   AND MUST BE CONVERTED TO CM**2/GM OF GAS 
C   GRAPHITE
	IF(ICHEM.EQ.1) THEN
		Y1(NBIN) = ENH8*0.5*((BNU1*DCAPCA(NU,IA1,I))+
     1			   (BNU2*DCAPCA(NU,IA2,I)))
	ELSE
C   SILICATE
		Y2(NBIN) = ENH8*0.5*((BNU1*DCAPSA(NU,IA1,I))+
     1   	           (BNU2*DCAPSA(NU,IA2,I)))
        END IF
	BNU1 = BNU2
100	CONTINUE
C   INTEGRAL OVER GRAIN SIZE
	B1 = 0.
	B2 = 0.
	CALL TWOTEG2(AC,Y1,B1,NC(I),C1,AS,Y2,B2,NS(I),C2)
	DCBNU = B1+B2
	RETURN
	END	
