	SUBROUTINE GOPAC(T,CAP,CSCA,DCACA,DCASA,L)
        LOGICAL MANTLES
	DIMENSION AX(25),AQX(100),MX(25),DAX(25),YEXT(25)
	DIMENSION YSCA(25),CG(25),CAXPA(25),ZCAP(150),CAXA(25)
        DIMENSION CSCA(150),CAP(150),CAPEXT(150),CX(25),ZCSCA(150)
	DIMENSION DCACA(150,25),DCASA(150,25),YG(25),YG2(25),AVEGC(150)
	DIMENSION GC2(150),AXM(25)
	COMMON/QUES/QEXT(150,100,2),QSCA(150,100,2),QPR(150,100,2)
	COMMON/QICE/QICEXT(150,100,2),QICSCA(150,100,2),QICPR(150,100,2)       
	COMMON/ALAM/ALAMDA(83),ASTEPC,ASTEPSI,QAC(100),QASI(100)
	COMMON/GDIST/ROG(2),AG(2,25,200),AN(2,25,200),W(2,25,200)
	COMMON/PHREQ/NF,FREQ(150),WF(150)
	COMMON/GEE/G(150),CPR(150),VOPAC
	COMMON/CAPF/CAPFC(25),CAPFSI(25)
	COMMON/CCCC/CROSC,CPLKC
	COMMON/TEST/CASPA(150,25),CACPA(150,25)
	COMMON/PICH/PI,C,AMH,UH,ENH
	COMMON/NNN/NC(200),NS(200),DENS,NCSAV,NSSAV
	COMMON/WTS/A(25),CC(25,200),CS(25,200),CONST(2,25)
	COMMON/DUST2/GMIE(150,200),RSTAR,DCASC(150,200)
	COMMON/DUST4/DCAPCA(150,25,200),DCAPSA(150,25,200),DTEMP(2,25,200),
     1	DPLNK(2,25,200),DCHIJ(2,25,200)
	COMMON/BIGS/XJNU(150,200),XHNU(150,200),FKJ(150,200),FHJ(150),
     1	QSP(150,200),HHNU(150)
	COMMON/MODEL/IRADTR
C  control for ice mantles  (DOSW 7/27/87)
        COMMON/DUST6/MANTLES,RMANTLE,TICE 
c        RMANTLE = 5.00E-3   
C   removed from here to allow for NAMELIST control
	ENH8 = ENH/1.0E+8
	DO 900 ICHEM = 1,2
	GO TO (910,920) ICHEM
910	ASTEP = ASTEPC
	DO 911 N=1,100
911	AQX(N) = QAC(N)
	DO 912 J=1,25
	CX(J)=CC(J,L)
912	CONTINUE
	NA = NC(L)
	GO TO 905
920	ASTEP = ASTEPSI
	DO 921 N=1,100
	AQX(N) = QASI(N)
921	CONTINUE
	DO 922 J=1,25
	CX(J)=CS(J,L)
922	CONTINUE
	NA = NS(L)
905	CONTINUE
	DO 100 J=1,25
	AX(J) = AG(ICHEM,J,L)
        AXM(J) = AX(J)
C ICE MANTLES:   
        IF(MANTLES) THEN      
C     dust is to have an ice mantle
	   IF (T.LE.TICE) THEN   
C     mantles are added only for T < TICE
              AXM(J) = AX(J) + RMANTLE  
C     RMANTLE is controled by NAMELIST3
	   END IF
        END IF
	IF(AX(J).LT.0.004) AX(J) = 0.004
	AXL = ALOG10(AX(J))
	MM = INT((AXL-AQX(1))/ASTEP)+1
	MX(J) = MM
		IF((AQX(MM+1)-AQX(MM)).EQ.0) THEN
          WRITE(6,*)'MM,J,IC,AP,AQ,A',MM,J,ICHEM,AQX(MM+1),AQX(MM),AX(J)
		END IF
	DAX(J) = (AXL-AQX(MM))/(AQX(MM+1)-AQX(MM))
100	CONTINUE
C    FREQUENCY LOOP
	DO 300 ILAM=1,NF
	INEW = 1+NF-ILAM
C    BIN LOOP
	DO 200 J=1,25
        CEXT = 0.0	
	CSCAA = 0.0
	CG(J) = 0.0
	MM = MX(J)
	DD = DAX(J)
	PIASQ = PI*AXM(J)**2
	PIVOL = 4.0*PIASQ*AXM(J)/3.0
C   CEXT = Qext,  CSCAA = Qsca,  CG = PI*A**2*(Qabs + (1-g)Qsca)
C   The test for MANTLES was added 11/6/87 by dosw.  It was overlooked until
c   this time.  Only a few models have been run.  Turning off mantles should
c   work now.  (MGW pointed out this mistake in a mail message to me.)
C
        IF((MANTLES).AND.(T.LT.TICE)) THEN 
C   grain has a mantle
	CEXT =  QICEXT(ILAM,MM+1,ICHEM)*DD+(1.0-DD)*QICEXT(ILAM,MM,ICHEM)
	CSCAA = QICSCA(ILAM,MM+1,ICHEM)*DD+(1.0-DD)*QICSCA(ILAM,MM,ICHEM)
	CG(J) = +PIASQ*CEXT-(PIASQ*(QICPR(ILAM,MM+1,ICHEM)*DD+(1.0-DD)*
     1	         QICPR(ILAM,MM,ICHEM)))
        ELSE 
C   bare grains
	CEXT =  QEXT(ILAM,MM+1,ICHEM)*DD+(1.0-DD)*QEXT(ILAM,MM,ICHEM)
	CSCAA = QSCA(ILAM,MM+1,ICHEM)*DD+(1.0-DD)*QSCA(ILAM,MM,ICHEM)
	CG(J) = +PIASQ*CEXT-(PIASQ*(QPR(ILAM,MM+1,ICHEM)*DD+(1.0-DD)*
     1	         QPR(ILAM,MM,ICHEM)))
        END IF
C   YG = g*Qsca
        YG(J) =  ABS((PIASQ*CEXT)-CG(J))/PIASQ
C   YG2 = Qsca used in normalizing g
	YG2(J) = CSCAA
C    Load arrays for integration over grain size. These are bin endpoints. 
	YEXT(J) = CEXT
	YSCA(J) = CSCAA
C   Load arrays for integration over frequency. CAXA = PI*A**2*Qabs used in
C   Planck mean and thermal emmissivity. CAXPA = PI*A**2*(Qabs + (1-g)Qsca)/
C   4/3*PI*A**3*RO . ie Radiation pressure cross section/grams of grain.
	CAXA(J) = (CEXT-CSCAA)*PI*(AXM(J)**2)
	CAXPA(J) = CG(J)*1.0E+4/(PIVOL*ROG(ICHEM))
200	CONTINUE
C
C    END OF SIZE LOOP
C
	DO 205 J=2,25
	AAVE = (AXM(J)+AXM(J-1))*0.5
	YEXT(J-1) = (YEXT(J)*(AXM(J)**2)+YEXT(J-1)*(AXM(J-1)**2))*0.5*PI
c	YEXT(J-1) = (YEXT(J)+YEXT(J-1))*0.5*PI*AAVE**2
	YSCA(J-1) = (YSCA(J)*(AXM(J)**2)+YSCA(J-1)*(AXM(J-1)**2))*0.5*PI
c	YSCA(J-1) = (YSCA(J)+YSCA(J-1))*0.5*PI*AAVE**2
	YG(J-1) = (YG(J)+YG(J-1))*0.5*PI*AAVE*AAVE
	YG2(J-1) = (YG2(J)+YG2(J-1))*0.5*PI*AAVE*AAVE
205	CONTINUE
	CALL TWOTEG(AX,YEXT,SIG1,YSCA,SIG2,CX,25)
	CALL TWOTEG(AX,YG,G1,YG2,G2,CX,25)
	GO TO (210,220) ICHEM
210	CAPEXT(ILAM) = SIG1*ENH8
	CSCA(ILAM) = SIG2*ENH8
	CAP(ILAM) = CAPEXT(ILAM)-CSCA(ILAM)
	AVEGC(ILAM) = G1*ENH8
	GC2(ILAM) = G2*ENH8
	DO 211 J=1,25
	DCACA(INEW,J) = CAXA(J)
211	CACPA(ILAM,J) = CAXPA(J)
	GO TO 300
220	CONTINUE
C   Add graphite and silicate distributions
	AVEGT = AVEGC(ILAM) + G1*ENH8
	GT = GC2(ILAM) +G2*ENH8
	CPR(ILAM) = SIG1*ENH8
	CAPEXT(ILAM) = CAPEXT(ILAM) + SIG1*ENH8
	CSCA(ILAM) = CSCA(ILAM) + SIG2*ENH8
	CAP(ILAM) = CAPEXT(ILAM)-CSCA(ILAM)
	GMIE(INEW,L) = 0.0
	IF(GT.NE.0) GMIE(INEW,L) = AVEGT/GT
	DO 221 J=1,25
	DCASA(INEW,J) = CAXA(J)
221	CASPA(ILAM,J) = CAXPA(J)
300	CONTINUE	
C
C     END OF FREQUENCY LOOP
C
900	CONTINUE
	VOPAC = CAPEXT(9)
        VEXTP = CPR(9)
C  CALCULATE ROSSELAND AND PLANK MEAN OPACITY
	GF1 = 3.288064E+15
	NX = NC(L)
	DO 9020 ICHEM = 1,2
	IF(ICHEM.EQ.2) NX = NS(L)
	DO 9020 IA=1,25
	X1 = 157808.0/DTEMP(ICHEM,IA,L)
	CPL=0.0
	CRO = 0.0
	CFC = 0.0
	CFSI = 0.0
	D1 = 0.0
	D2 = 0.0
	D3 = 0.0
	DCPL = 0.0
	DO 9010 IF=1,NF
	IL = NF-IF+1
	CAPX = DCACA(IF,IA)
	IF(ICHEM.EQ.2) CAPX = DCASA(IF,IA)
	XX = X1*FREQ(IF)/GF1
	EX = EXP(-XX)
	B = (XX**3)*EX/(1.0-EX)
	DBDT = XX*B/(1.0-EX)
	CPL = CPL+WF(IF)*FREQ(IF)*(CAPEXT(IL)-CSCA(IL))*B
	DCPL = DCPL +WF(IF)*FREQ(IF)*CAPX*B
	D1 = D1+WF(IF)*FREQ(IF)*B
	IF(CAPEXT(IL).GT.0.0) THEN
	CRO = CRO+(WF(IF)*FREQ(IF)*DBDT/(CAP(IL)+CSCA(IL)))
	END IF
	D2 = D2+WF(IF)*FREQ(IF)*DBDT
	IF(IRADTR.EQ.0) THEN
       	     CFC = CFC+(WF(IF)*FREQ(IF)*DBDT/CACPA(IL,IA))
	     CFSI = CFSI+(WF(IF)*FREQ(IF)*DBDT/CASPA(IL,IA))
	ELSE
	     CFC  = CFC+WF(IF)*FREQ(IF)*XHNU(IF,L)*CACPA(IL,IA)
	     CFSI = CFSI+WF(IF)*FREQ(IF)*XHNU(IF,L)*CASPA(IL,IA)
	     D3   = D3+WF(IF)*FREQ(IF)*XHNU(IF,L)
	END IF
9010	CONTINUE
	CPLKC = CPL/D1
	DPLNK(ICHEM,IA,L) = DCPL/D1
	IF(CRO.NE.0) THEN
	CROSC = D2/CRO
	END IF
   	IF(IRADTR.EQ.0) THEN
 	     CAPFC(IA) = D2/CFC
	     CAPFSI(IA) = D2/CFSI
	ELSE
	     CAPFC(IA) = CFC/D3
	     CAPFSI(IA) = CFSI/D3
	END IF 
9020	CONTINUE
	DO 925 ILA = 1,NF
	ILB = NF-ILA+1
	ZCAP(ILA) = CAP(ILB)
	ZCSCA(ILA) = CSCA(ILB)
925	CONTINUE
	DO 930 ILA = 1,NF
	CAP(ILA) = ZCAP(ILA)
	CSCA(ILA) = ZCSCA(ILA)
930	CONTINUE
	RETURN
	END

