        subroutine ldisk(fre,teff,reff,alnd)
c program to calculate disk luminosity
        dimension td(500),rd(500),bnud(500)
        pi = 3.1415926
        sig  = 5.66e-5 
        alum = 4.0*pi*reff**2*sig*teff**4
        aldisk = 0.25*alum
        tdisks  = (aldisk/(4.0*pi*sig*reff**2))**0.25
        irmax = 500
        rmax = 100.0*1.5e13
        rstep = (alog10(rmax)-alog10(reff))/(irmax-1)
        do 100 ir = 1,irmax
        rd(ir) = 10.00**(alog10(reff)+float(ir-1)*rstep)
        td(ir) = tdisks*(rd(ir)/reff)**(-0.75)
        bnud(ir) = 2.0*pi*bnuf(fre,td(ir))*2.0*pi*rd(ir)
 100    continue
        alnd = area(rd,bnud,irmax,2)
        return
        end

