        SUBROUTINE MEANT(IR,T,TRAD)
C   MEANT LIGHT - THIS SUBROUTINE CALCULATES AN AREA WEIGHTED MEAN GRAIN TEMP
C   Bolometric meant temperature added
C   IR = INPUT RADIAL GRID POINT
C   T  = OUTPUT TEMPERATURE
	COMMON/INTRG/II,III,NFREQ
        COMMON/BIGS/XJNU(150,200),XHNU(150,200),FKJ(150,200),FHJ(150),
     A  QSP(150,200),HHNU(150)
	COMMON/GDIST/ROG(2),AG(2,25,200),AN(2,25,200),W(2,25,200)
        COMMON/REAL3/ABH,ABHE,EL
        COMMON/BCREK/ AJ(200),AH(200),AK(200),CPLNK(200)
        COMMON/ATMSP/ TEMP(200),DENST(200)
        COMMON/DUST4/DCAPCA(150,25,200),DCAPSA(150,25,200),
     -         DTEMP(2,25,200),DPLNK(2,25,200),DCHIJ(2,25,200)
	COMMON/NNN/NC(200),NS(200),DENS,NCSAV,NSSAV
	COMMON/WTS/A(25),CC(25,200),CS(25,200),CONST(2,25)
	COMMON/PHREQ/NF,FREQ(150),WF(150)
        COMMON/MEAN/BMEANC(25),BMEANS(25)
	COMMON/DUST5/DBSORC(150,200)
        COMMON/FRAC/ P(200),R(300),NR,NP,INDEX(200)
	COMMON/CAPT/CJC(200),CBC(200),CJS(200),CBS(200),CRC(200),CRS(200),
     .              CHC(200),CHS(200),CRT(200),CPC(200),CPS(200)
  	DIMENSION CANU(200),RSH(200),RSHAV(200)
        DIMENSION CSCA(150),CAP(150),CAPEXT(150),CX(25),ZCSCA(150)
        DIMENSION C1(25),C2(25),Y1(25),Y2(25),Y3(25),Y4(25),AS(25),
     .         AC(25)
	AMH = 1.67E-24
	UH = (ABH+4.0*ABHE)/ABH
	ENH = 1.0/(UH*AMH)
	ENH8 = ENH/1.0E+8
	PI = 3.1415926
	DO 100 I=1,25
        AC(I) = AG(1,I,IR)
        AS(I) = AG(2,I,IR)
	C1(I) = CC(I,IR)
	C2(I) = CS(I,IR)
 100    CONTINUE
c        write(30,*)'IR,AC1,AC25,C11,C125',IR,AC(1),AC(25),C1(1),C1(24)
c        write(30,*)'IR,AS1,AS25,C21,C225',IR,AS(1),AS(25),C2(1),C2(24)
        areac = 0.0
        areas = 0.0
        avetc = 0.0
        avets = 0.0
        do 150 m=2,25
        aveac = (ac(m-1)+ac(m))/2.0
        delac = (ac(m)-ac(m-1))
        aveas = (as(m-1)+as(m))/2.0
        delas = (as(m)-as(m-1))
        areac = areac + c1(m-1)*aveac**2*delac
        areas = areas + c2(m-1)*aveas**2*delas
        avetc = avetc + c1(m-1)*aveac**2*dtemp(1,m,ir)*delac
        avets = avets + c2(m-1)*aveas**2*dtemp(2,m,ir)*delas
 150  continue
        t = (avets + avetc)/(areac + areas)
C   ENERGY WEIGHTED MEAN T =
C    INTEGRAL [ n(a)Qb(pi*a**2)T**4 da]/ INTEGRAL [ n(a)Qb(pi*a**2) da]**.25
	DO 200 IA=2,25
	AC1 = DPLNK(1,IA,IR)*(DTEMP(1,IA,IR)**4)
 	AC2 = DPLNK(1,IA-1,IR)*(DTEMP(1,IA-1,IR)**4)
	AS1 = DPLNK(2,IA,IR)*DTEMP(2,IA,IR)**4
	AS2 = DPLNK(2,IA-1,IR)*DTEMP(2,IA-1,IR)**4
	Y1(IA-1) = 0.5*(AC1+AC2)	
200	Y2(IA-1) = 0.5*(AS1+AS2)
	CALL TWOTEG2(A,Y1,B1,25,C1,A,Y2,B2,25,C2)
	DNUM = B1+B2
C	TYPE*,'B1+B2',DNUM
	DO 300 IA=2,25
	AC1 = DPLNK(1,IA,IR)
 	AC2 = DPLNK(1,IA-1,IR)
	AS1 = DPLNK(2,IA,IR)
	AS2 = DPLNK(2,IA-1,IR)
	Y1(IA-1) = 0.5*(AC1+AC2)	
300	Y2(IA-1) = 0.5*(AS1+AS2)
	CALL TWOTEG2(A,Y1,B1,25,C1,A,Y2,B2,25,C2)
	DNOM = B1+B2
 	TRAD = (DNUM/DNOM)**0.250
c        write(30,*)'avets,avetc,areac,areas',avets,avetc,areac,areas
	RETURN
	END



