      SUBROUTINE VAREDQ(NU)
      INTEGER PINDEX
      DOUBLE PRECISION EEZ,YYZ,SSZ,XD,YPRD,THET,VERSE,EMB,ENB,DELTH,
     1   RR4,RRK,ETFM,ETKM,XD1,XD2,XD3,DDZ,EMC,ENC,XC1,XC2,ZC,
     2   XB1,XB2,ZB,ZB1,ZB2,XA1,ZA,ZA1,ZA2,PRT1,PRT2,TMP,RM4,RZ4,RP4,
     3   HPNU,HZ,HP,RRM4,RRZ4,RRP4
      COMMON/CONSTS/ SIG1,C,PI
      COMMON/PHREQ/ NF,FREQ(150),WF(150)
      COMMON/FRAC/ P(200),R(300),NR,NP,PINDEX(200)
      COMMON/REAL/ HZORSQ,TEFF
      COMMON/INTRG/  II,III,NFREQ
      COMMON/ATMSP/ TT(200),ROO(200)
      COMMON/RT/ CA(150,200),CASC(200),CROSS(200)
      COMMON/BLANK3/ EEZ(200),YYZ(200),SSZ(200),XM(200),YM(200),
     A YPR(200),RM(200)
      COMMON/RT2/ CANU(200)
      COMMON/BIGS/XJNU(150,200),XHNU(150,200),FKJ(150,200),
     A            FHJ(150),QSP(150,200),HHNU(150)
      COMMON/DUST2/GMIE(150,200),RSTAR,DCASC(150,200)
      COMMON/ARE/REFF
      COMMON/FFR/NTCRR
      COMMON/CASES/ ITER,NTCREK 
      DIMENSION THET(200),YPRD(200),XD(200)
      DIMENSION TEGS(200),SM(200)
      FRE=FREQ(NU)
C  LN(QSP)=INTEGRAL(3.-1./F)/R*DR
      IFORW=1
      IDRIV=0
C      
C CALCULATE AUER SPHERICALITY FUNCTION, QSP
C NOTE: ln(QSP)=INTEGRAL(3-1/F)
      DO 9010 I=1,III
      RM(I)=R(I)
      XM(I)=ALOG(R(I))
 9010 YM(I)=(3.-1./FKJ(NU,I))
C
C  ONESPL AND XISPLI INTERGRATE OVER R USING CUBIC SPLINES
C  NOTE: IFORW=1  HENCE THE INTEGRAL IS FROM R(1) TO R(III)
      CALL ONESPL(XM,YM,SM,YP1,YPN,YPR,III,IDRIV)
      CALL XISPLI(XM,YM,SM,TEGS,III,IFORW)
C
C  END SPLINE INTEGRAL 
      DO 9012 I=1,III
 9012 QSP(NU,I)=EXP(TEGS(I))
C  END CALCULATION OF SPHERICALITY FACTOR QSP

C     DO 301 J=1,NP,NP-1
C      I=PINDEX(J)
C      WRITE(11,601) NU,I,R(I),CANU(I),CASC(I),FKJ(NU,I),QSP(NU,I)
  601 FORMAT(' R,CA,CASC,F,Q',2I5,5E15.8)
  301 CONTINUE
C   END SPHERICALITY FACTOR
C
C  INNER BOUNDARY
      HBC=HZORSQ
      XBNU = BNUF(FRE,TEFF)
      HHNU(NU) = 0.25*XBNU*(REFF/R(1))**2
C  END FINDING MONOCHROMATIC HNU
C 
C  OUTER BOUNDARY
      CALL ISRFSUB(FREQ(NU),NU,AIMINUS)
      HBCO = 0.25*AIMINUS

      RZSQ=R(1)**2
      RZRO=R(1)
C
C  GET A GENERALISED OPTICAL DEPTH THETA(NU)
C  THETA=OPACC*RO*Q*DR/RSQ
C  FOR DUST CASE   OPACC = (CAP + SIGMA(1-g))
C
      DO 5003 I=1,III
      TEGS(I) = CA(NU,I)*QSP(NU,I)/((R(I)/RZRO)**2)
5003  CONTINUE
      CALL TAUSCL(TEGS,ROO,RM,XM,III)
      DO 4991 I=1,III
 4991 THET(I)=XM(I)
C  NOW HAVE GENERALISED OPTICAL DEPTH
C
C     START NON-CONSERVATIVE CASE
      I=1
C
C     SUBROUTINE ETZET OBTAINS THE MONCHROMATIC OPACITY AT FREQ NU AT 
C     SPATIAL STEP I.  
C     NOTE: ET=ABSORPTION(KAPA)=(TOTAL-SCATTER)OPACITY
C
      CALL ETZET(I,NU,ETM)
C
C  SUBROUTINE SORCE OBTAINS THE THERMAL PART OF THE SOURCE FUNCTION
C  i.e. BSORC=KAPPA*BNU
C  M,Z, AND P ARE FINAL LETTERS THAT REFER TO SPATIAL POSITION
C  i.e. ...M=R MINUS DELTA R, ...Z=R, ...P=R PLUS DELTA R
C  THET=GENERALIZED OPTICAL DEPTH=KRO*Q*dR/RSQ
C
      CALL SORCE(I,NU,BSORM)
      EMB=0.
      ENB=+HHNU(NU)*(R(1)/RZRO)**2
      J1=1
      J2=2
      CALL ETZET(J2,NU,ETP)
      CALL SORCE(J2,NU,BSORP)
      DELTH=DABS(THET(III)-THET(II))
      RR4=(DELTH/3.)*(R(J1)/RZRO)**4/(CANU(J1)*QSP(NU,J1))
      RRK=(DELTH/3.)*(R(J2)/RZRO)**4/(CANU(J2)*QSP(NU,J2))
      ETFM=ETM/(FKJ(NU,J1)*QSP(NU,J1))
      ETKM=ETP/(FKJ(NU,J2)*QSP(NU,J2))
C
C  GET A,B,C,AND D FOR FIRST ROW IN THE MATRIX (INNER EDGE)
C  Spline based difference equation for dY/dtheta at inner edge:
C  dY/dtheta = AY0 + B  = -M0*H0/2 + (Yp-Y0)/H0 -H0*(Mp-M0)/6
C  Where:
C                       y    = fqJ
C			H0   = ABS(theta(III)-theta(II))
C			M0   = Second derivative at Y0 = alfa0*y0 + beta0
C			Mp   = Second derivative at Yp = alfap*Yp + betap
C			alfa = (r**4)*K(abs)/(q*K(ext)*f*q)
C			beta = (r**4)*K(abs)*B/(q*K(ext))
C  In tridiagnal form:
C  Y0*(alfa0*H0/3 + 1/H0) - Yp*(1/H0 - H0*alfap/6) = H0*beta0/2 + H0betap/6
C      ------ ZB -------        ------- ZC ------    --- XD2 --   --- XD3 -
C                                                    - (r**2)*H       
C	                                             --- XD1 --		
      XD1=+ENB
      XD2=+RR4*BSORM
      XD3=+0.5*RRK*BSORP
      DDZ=XD1+XD2+XD3
      XC1=1./DELTH
      XC2=-0.5*RRK*ETKM
      ZC=XC1+XC2
      XB1=-EMB+1./DELTH
      XB2=+RR4*ETFM
      ZB=XB1+XB2
      ZA=0.
      VERSE=1./ZB
C
C  DIVIDE BY B1 TO GET SSZ AMD EEZ IN THE FIRST ROW OF THE MATRIX
      EEZ(I)=VERSE*DDZ
      SSZ(I)=VERSE*ZC
      RP4=(R(I+1)/RZRO)**4
      RZ4=(R(I)/RZRO)**4
      HPNU=DELTH
      BSORZ=0.
C      END FIRST STEP
C
C      FORWARD ELIMINATION FOR SPATIAL STEPS I=2,III
    1 CONTINUE
      I=I+1
      I1=I-1
C
C     GO TO 14 IF THIS IS THE LAST STEP
      IF(I-III) 13,14,14
   13 CONTINUE
C
C     OBTAIN THERMAL OPACITIES AND SOURCES FOR THE MIDDLE STEPS
      CALL ETZET(I-1,NU,ETM)
      CALL SORCE(I-1,NU,BSORM)
      CALL ETZET(I,NU,ETZ)
      CALL SORCE(I,NU,BSORZ)
      CALL ETZET(I+1,NU,ETP)
      CALL SORCE(I+1,NU,BSORP)
      RM4=RZ4
      RZ4=RP4
      RP4=(R(I+1)/RZRO)**4
      J=III-I+1
      HZ=HPNU
      HPNU=DABS(THET(J)-THET(J-1))
      HP=HPNU
      RRM4=(HZ*HZ/6.)*RM4/(CANU(I-1)*QSP(NU,I-1))
      RRZ4=(HZ*HP/6.)*RZ4/(CANU(I)*QSP(NU,I))
      RRP4=(HP*HP/6.)*RP4/(CANU(I+1)*QSP(NU,I+1))
C
C     FIND THE MATRIX ELEMENTS A,B,C,AND D FOR THE (I+1)TH ROW OF THE MATRIX
C     EQUATION
C
      XD1=RRM4*HP*BSORM
      XD2=RRZ4*2.*(HZ+HP)*BSORZ
      XD3=RRP4*HZ*BSORP
      DDZ=(XD1+XD2+XD3)
      XA1=-HP*RRM4*(ETM/(FKJ(NU,I-1)*QSP(NU,I-1)))
      XB1=+2*(HZ+HP)*RRZ4*(ETZ/(FKJ(NU,I)*QSP(NU,I)))
      XC1=-HZ*RRP4*(ETP/(FKJ(NU,I+1)*QSP(NU,I+1)))
      ZC=HZ+XC1
      ZA1=XA1
      ZA2=HP
      ZA=ZA1+ZA2
      ZB1=XB1
      ZB2=HZ+HP
      ZB=ZB1+ZB2
      PRT1=ZB1-ZA1*SSZ(I1)
      PRT2=ZB2-ZA2*SSZ(I1)
      TMP=PRT1+PRT2
      VERSE=1./TMP
C
C     SUBRACT A FROM ALL ELEMENTS IN THE ITH ROW AND DIVIDE THE ITH ROW OF THE
C     MATRIX BY (B-AS(I-1)) TO GET UNITY ON THE UPPER RIGHTHAND SIDE DIAGONAL
C     AND ON THE RIGHTHAND SIDE OF THE MOMENT EQUATION
C
      EEZ(I)=VERSE*(DDZ+ZA*EEZ(I1))
      SSZ(I)=VERSE*ZC
      GO TO 1
C
C      LAST STEP OF OUTER ELIMINATION
   14 CONTINUE
      I=III
      J1=III
      J2=II
C
C     GET THERMAL OPACITY AND THERMAL SOURCE FUNCTION AT THE LAST SPATIAL
C     STEP i.e. AT THE BOTTOM ROW OF THE MATRIX EQUATION
C
      CALL ETZET(III,NU,ETM)
      CALL SORCE(III,NU,BSORM)
      CALL ETZET(J2,NU,ETP)
      CALL SORCE(J2,NU,BSORP)
      ENC=2.0*HBCO*(R(J1)/RZRO)**2
      EMC=FHJ(NU)/(FKJ(NU,J1)*QSP(NU,J1))*(R(J1)/RZRO)**2
      DELTH=DABS(THET(2)-THET(1))
      RR4=(DELTH/3.)*(R(J1)/RZRO)**4/(CANU(J1)*QSP(NU,J1))
      RRK=(DELTH/3.)*(R(J2)/RZRO)**4/(CANU(J2)*QSP(NU,J2))
      ETFM=ETM/(FKJ(NU,J1)*QSP(NU,J1))
      ETKM=ETP/(FKJ(NU,J2)*QSP(NU,J2))
C
C     GET A,B,C,AND D ELEMENTS OF THE LAST ROW OF MATRIX EQUATIONS
      XD1=+ENC
      XD2=+RR4*BSORM
      XD3=+0.5*RRK*BSORP
      DDZ=XD1+XD2+XD3
      ZC=0.
      ZA1=1./DELTH
      ZA2=-0.5*RRK*ETKM
      ZA=ZA1+ZA2
      ZB1=ZA1
      ZB2=RR4*ETFM
      ZB=ZB1+ZB2+EMC
      PRT1=ZB1-ZA1*SSZ(II)
      PRT2=ZB2-ZA2*SSZ(II)
      TMP=PRT1+PRT2+EMC
      VERSE=1./TMP
C
C     GET THE VALUE OF EEZ OF THE RIGHTHAND SIDE OF THE MATRIX EQUATION
C     FOR THE LAST ROW
C
      SSZ(III)=0.
      EEZ(III)=VERSE*(DDZ+ZA*EEZ(II))
C
C     SOLVE BY BACKWARD SUBSTITUTION FOR YYZ=F*Q*J AT ALL RADII
C
      YYZ(III)=EEZ(III)
      DO 760 J=2,III
      I=III-J+1
      I1=I+1
      YYZ(I)=EEZ(I)+SSZ(I)*YYZ(I1)
      DELTH=DABS(THET(J)-THET(J-1))
760   CONTINUE
      IDRIV=1
C
C      CALCULATE MEAN INTENSITY JNU AND FLUX MOMENT HNU
C      NOTE: H=Y/DTHETA
C      GET DERIVATIVE VIA SPLINE FIT OF Y VS THETA
C
      DO 21 I=1,III
      J=III-I+1
      XD(J)=THET(I)
      IF(YYZ(I).LT.0.) YYZ(I)=0.
      XJNU(NU,I)=SNGL(YYZ(I)/(FKJ(NU,I)*QSP(NU,I)))
   21	CONTINUE
C XHNU should always be the net H
      XHNU(NU,1)=HHNU(NU)
      XHNU(NU,III)=FHJ(NU)*XJNU(NU,III)-2.0*HBCO
      CALL ONSPLD(XD,YYZ,YPRD,III,IDRIV)
      DO 7 I=2,II
         XHNU(NU,I)=SNGL(YPRD(I)/(R(I)/RZRO)**2)
    7 CONTINUE
      RETURN
      END







